<?php

namespace Bixo\Schedule\Http\Controllers;

use App\Http\Controllers\ActionController as BaseController;
use Exception;
use Bixo\Schedule\Actions\FollowUpsAction;
use Bixo\Schedule\Http\Requests\FollowUpsActionRequest;
use Bixo\Schedule\Http\Resources\FollowUpsResource;
use Bixo\Schedule\Models\FollowUps;

/**
 * Admin web controller class.
 */
class FollowUpsActionController extends BaseController
{

    /**
     * Action controller function for follow_ups.
     *
     * @param Model $model
     * @param action next action for the model.
     *
     * @return Response
     */
    public function __invoke(FollowUpsActionRequest $request, FollowUps $follow_ups, $action)
    {
        try {
            $request = $request->all();
            $follow_ups = FollowUpsAction::run($action, $follow_ups, $request);

            $data = new FollowUpsResource($follow_ups);
            return $this->response->message(trans("messages.success.{$action}", ['Module' => trans('schedule::follow_ups.name')]))
                ->code(204)
                ->data(compact('data'))
                ->status('success')
                ->url(guard_url('schedule/follow_ups/' . $follow_ups->getRouteKey()))
                ->redirect();
        } catch (Exception $e) {
            return $this->response->message($e->getMessage())
                ->code(400)
                ->status('error')
                ->url(guard_url('schedule/follow_ups/' . $follow_ups->getRouteKey()))
                ->redirect();
        }
    }

    public function notify(){
        
    }
}
