<?php

namespace Bixo\Schedule\Http\Controllers;

use App\Http\Controllers\Controller as BaseController;
use Exception;
use Bixo\Schedule\Http\Requests\FollowUpsActionsRequest;
use Bixo\Schedule\Actions\FollowUpsActions;

/**
 * Admin web controller class.
 */
class FollowUpsActionsController extends BaseController
{

    /**
     * Action controller function for follow_ups.
     *
     * @param Model $model
     * @param action next action for the model.
     *
     * @return Response
     */
    public function __invoke(FollowUpsActionsRequest $request, $action)
    {
        try {
            $follow_ups = FollowUpsActions::run($request, $action);
            return $this->response->message(trans('messages.success.updated', ['Module' => trans('schedule::follow_ups.name')]))
                ->code(204)
                ->data(compact('data'))
                ->status('success')
                ->url(guard_url('schedule/follow_ups/' . $action))
                ->redirect();
        } catch (Exception $e) {
            return $this->response->message($e->getMessage())
                ->code(400)
                ->status('error')
                ->url(guard_url('schedule/follow_ups/' . $action))
                ->redirect();
        }
    }
}
