<?php
namespace Bixo\Schedule\Notifications;

use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Notifications\Messages\MailMessage;
use Illuminate\Notifications\Notification;
use Bixo\Schedule\Events\FollowUpsAction as FollowUpsActionEvent;
use Bixo\Schedule\Models\FollowUps;

class FollowUpsAction extends Notification implements ShouldQueue
{
    use Queueable;

    protected $event;
    protected $follow_ups;
    protected $action;
    protected $request;

    /**
     * Create a new notification instance.
     *
     * @param FollowUpsActionEvent $follow_ups
     */
    public function __construct(FollowUpsActionEvent $follow_ups)
    {
        $this->action = $event->action;
        $this->follow_ups = $follow_ups;
        $this->request = $event->request;
        $this->event = $event;

    }

    /**
     * Get the mail representation of the notification.
     *
     * @param mixed $notifiable
     * @return \Illuminate\Notifications\Messages\MailMessage
     */
    public function toMail($notifiable)
    {
        return (new MailMessage)
            ->subject('FollowUps Approved - ' . config('app.name'))
            ->view('schedule::follow_ups.email.action', ['data' => $this->follow_ups]);
    }

    /**
     * Get the notification's delivery channels.
     *
     * @param object $notifiable
     * @return array<int, string>
     */
    public function via(object $notifiable): array
    {
        return ['mail'];
    }
}
