<?php

namespace Bixo\Schedule\Policies;

use Bixo\Schedule\Models\FollowUps;
use Illuminate\Foundation\Auth\User as Authenticatable;

trait FollowUpsAction
{

    /**
     * Determine if the given user can copy the given follow_ups.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function copy(Authenticatable $user, FollowUps $follow_ups)
    {

        if ($authUser->canDo('schedule.follow_ups.action.copy')) {
            return true;
        }

        $this->model->is_owner;
    }

    /**
     * Determine if the given user can empty the given follow_ups.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    function empty(Authenticatable $user, FollowUps $follow_ups) {

        if ($authUser->canDo('schedule.follow_ups.action.empty')) {
            return true;
        }

        $this->model->is_owner;
    }

    /**
     * Determine if the given user can transfer the given follow_ups.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function transfer(Authenticatable $user, FollowUps $follow_ups)
    {

        if ($authUser->canDo('schedule.follow_ups.action.transfer')) {
            return true;
        }

        $this->model->is_owner;
    }

}
