<?php


namespace Bixo\Schedule\Policies;

use Litepie\User\Interfaces\UserPolicyInterface;

trait FollowUpsReport
{

    /**
     * Determine if the given user can approve the given follow_ups.
     *
     * @param UserPolicyInterface $authUser
     *
     * @return bool
     */
    public function povote(UserPolicyInterface $authUser)
    {
        if ($authUser->canDo('schedule.follow_ups.report.povote')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the given user can approve the given follow_ups.
     *
     * @param UserPolicyInterface $authUser
     *
     * @return bool
     */
    public function report(UserPolicyInterface $authUser)
    {
        if ($authUser->canDo('schedule.follow_ups.report')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the given user can approve the given follow_ups.
     *
     * @param UserPolicyInterface $authUser
     *
     * @return bool
     */
    public function download(UserPolicyInterface $authUser)
    {
        if ($authUser->canDo('schedule.follow_ups.report.download')) {
            return true;
        }

        return false;
    }
}
